From 60209496396f4a965f64266b0357cd665979d732 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 29 2016 21:00:39 +0000
Subject: [PATCH 360/1001] More general backend improvements.


---

diff --git a/hubs/consumer.py b/hubs/consumer.py
index 6e938ae..b5fbe9d 100755
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -10,6 +10,7 @@ import datanommer.models
 import fedmsg.consumers
 import fedmsg.meta
 
+import hubs.app
 import hubs.models
 import hubs.widgets
 
@@ -24,6 +25,9 @@ def j(widget):
     return munch.Munch(dict(
         idx=widget.idx,
         hub_id=widget.hub_id,
+        hub=munch.Munch(dict(
+            name=widget.hub.name,
+        )),
         plugin=widget.plugin,
         config=widget.config,
         # TODO -- add other things here as we need it
@@ -103,7 +107,8 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
     def consume(self, raw_msg):
         session = self.make_session()
         try:
-            self.work(session, raw_msg)
+            with hubs.app.app.app_context():  # so url_for works
+                self.work(session, raw_msg)
             session.commit()  # transaction is committed here
         except:
             session.rollback()  # rolls back the transaction
@@ -158,6 +163,7 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
                 invalidate_cache(widget, **widget.config)
                 # Rebuild it.
                 module = hubs.widgets.registry[widget.plugin]
+                widget = hubs.models.Widget.by_idx(session, widget.idx)
                 module.data(session, widget, **widget.config)
                 # TODO -- fire off an EventSource notice that we updated stuff
 
diff --git a/hubs/default_config.py b/hubs/default_config.py
index a21f138..a452867 100755
--- a/hubs/default_config.py
+++ b/hubs/default_config.py
@@ -6,3 +6,5 @@ PROMOTED_GROUPS = [
 ]
 
 HUB_OF_THE_MONTH = 'commops'
+
+SERVER_NAME = '0.0.0.0:5000'
diff --git a/hubs/models.py b/hubs/models.py
index 9fe8f04..086e0b1 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -298,6 +298,12 @@ class Widget(BASE):
     index = sa.Column(sa.Integer, nullable=False)
     left = sa.Column(sa.Boolean, nullable=False, default=False)
 
+    @classmethod
+    def by_idx(cls, session, idx):
+        return session.query(cls).filter_by(idx=idx).first()
+
+    get = by_idx
+
     @property
     def config(self):
         return json.loads(self._config)
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 97d2fb5..5a16c2f 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -12,13 +12,12 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
         response = self.app.get('/%s/%i/json/' % (team, widget.idx))
         assert response.status_code == 200, response.status_code
         data = json.loads(response.data)
-        meetings = data['data']['meetings']["%s meeting" % team]
-        assert len(meetings) == 15, len(meetings)
-        assert team in meetings[0]['meeting_name']
+        meeting = data['data']['meetings']["%s meeting" % team]
+        assert team in meeting['meeting_name']
 
     def test_render_simple(self):
         team = 'i18n'
         widget = self.widget_instance(team, self.plugin)
         response = self.app.get('/%s/%i/' % (team, widget.idx))
         assert response.status_code == 200, response.status_code
-        assert 'The i18n meeting is in 14 hours' in response.data
+        assert 'The i18n meeting is in 14 hours' in response.data, response.data
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index e1fd798..78f6d99 100755
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -59,7 +59,7 @@ def smartcache(func):
     def inner(session, widget, *args, **kwargs):
         key = cache_key_generator(widget, args, kwargs)
         creator = lambda: func(session, widget, *args, **kwargs)
-        log.debug("Accessing cache key %s", key)
+        #log.debug("Accessing cache key %s", key)
         return cache.get_or_create(key, creator)
 
     return inner
diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
index 67bdc1c..58f36cb 100755
--- a/hubs/widgets/meetings.py
+++ b/hubs/widgets/meetings.py
@@ -6,6 +6,8 @@ from hubs.widgets import templating
 from hubs import validators
 from hubs import utils
 
+import hubs.models
+
 import arrow
 import collections
 import datetime
@@ -23,30 +25,34 @@ def next_meeting(meetings):
                             meeting['meeting_time_stop'])
         stop_dt = datetime.datetime.strptime(stop_string, "%Y-%m-%d %H:%M:%S")
 
-        if now < start_dt:
-            meeting['human_time'] = arrow.get(start_dt).humanize()
-            meeting['start_date'] = start_dt.strftime('%b %d')
-            meeting['stop_date'] = stop_dt.strftime('%b %d')
-            meeting['display_time'] = True
-            meeting['display_duration'] = False
-            # Just UTC for now until we do this on the client and can access
-            # their local with moment.js.
-            meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
-            meeting['stop_time'] = meeting['meeting_time_stop'][:-3] + " UTC"
-            meeting['location'] = meeting['meeting_location']
-            if '@' in meeting['location']:
-                meeting['location'] = '#' + meeting['location'].split('@')[0]
-            if stop_dt - start_dt >= datetime.timedelta(hours=24) :
-                meeting['display_time'] = False
-                if stop_dt - start_dt > datetime.timedelta(hours=24) :
-                    meeting['display_duration'] = True
-            return meeting
+        # Loop over them until we find a good one.
+        # Meetings before now are no good.  We want the first one after now.
+        if start_dt < now:
+            continue
+
+        meeting['start_dt'] = start_dt
+        meeting['start_date'] = start_dt.strftime('%b %d')
+        meeting['stop_date'] = stop_dt.strftime('%b %d')
+        meeting['display_time'] = True
+        meeting['display_duration'] = False
+        # Just UTC for now until we do this on the client and can access
+        # their local with moment.js.
+        meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
+        meeting['stop_time'] = meeting['meeting_time_stop'][:-3] + " UTC"
+        meeting['location'] = meeting['meeting_location']
+        if '@' in meeting['location']:
+            meeting['location'] = '#' + meeting['location'].split('@')[0]
+        if stop_dt - start_dt >= datetime.timedelta(hours=24) :
+            meeting['display_time'] = False
+            if stop_dt - start_dt > datetime.timedelta(hours=24) :
+                meeting['display_duration'] = True
+        return meeting
 
     return None
 
 
 chrome = panel('Reminders', key='meetings')
-templating.environment.filters['next_meeting'] = next_meeting
+templating.environment.filters['humanize'] = lambda d: arrow.get(d).humanize()
 template = templating.environment.get_template('templates/meetings.html')
 
 
@@ -59,17 +65,28 @@ def data(session, widget, calendar):
     url = base % calendar
     response = requests.get(url).json()
 
-    meetings = collections.defaultdict(list)
+    tmp = collections.defaultdict(list)
     for meeting in response['meetings']:
         meeting['meeting_information_html'] = utils.markup(
             meeting['meeting_information'])
-        meetings[meeting['meeting_name']].append(meeting)
+        tmp[meeting['meeting_name']].append(meeting)
+
+    meetings = {}
+    for title, items in tmp.items():
+        selected = next_meeting(items)
+        if not selected:
+            continue
+        meetings[title] = selected
 
-    return dict(meetings=dict(meetings))
+    return dict(meetings=meetings)
 
 
 @hint(categories=['fedocal'])
 def should_invalidate(message, session, widget):
+    # first, access our *old* cache value
+    old_data = widget.module.data(session, widget, **widget.config)
+
+
     # TODO -- we have a hard problem here.
     # There is no event which should invalidate this widget...
     # but we do need to expire ourselves after the date of the meeting we
